<?php

/**
*
*   These get called when uninstallg a package
*
*
*/

// cck

function package_builder_uninstall_cck($path) {
  foreach (glob($path . '/cck/*.cck') as $importfile) {
    $file = file_get_contents($importfile);
    $content = NULL;
    eval($file);
    if (!is_array($content)) {
      drupal_set_message("Error importing file $importfile", 'error');
      continue;
    }
    $node_type = $content['type']['type'];

//  Question: Should we delete nodes that belong to a content type we're removing?

//    $result = db_query("SELECT nid FROM {node} WHERE type = '%s'", $node_type);
//    while ($nid = db_result($result)) {
//      node_delete($nid);
//    }
    node_type_delete($node_type);
    drupal_set_message("Content type $node_type was deleted.");
  }
  menu_rebuild();
}

// remove views

function package_builder_uninstall_views($path) {
  require_once(drupal_get_path('module', 'views') . '/includes/view.inc');

  foreach (glob($path . '/views/*.view') as $importfile) {

    $view = NULL;
    $file = file_get_contents($importfile);
    eval($file);
    $real_view = views_get_view($view->name);
    $real_view->delete();
    drupal_set_message('View ' . $view->name . ' was deleted.');
  }
}

// remove roles

function package_builder_uninstall_roles($path) {
  foreach (glob($path . '/roles/*.role') as $importfile) {
    $role = array();

    ob_start();
    include $importfile;
    ob_end_clean();

    permissions_revoke_permissions($role['name'], $role['permissions']);
    $perms = permissions_get_permissions_for_role($role['name']);
    if (!count($perms)) {
      $rid = db_result(db_query("SELECT rid FROM {role} WHERE name = '%s'", $role['name']));
      db_query('DELETE FROM {role} WHERE rid = %d', $rid);
      db_query('DELETE FROM {permission} WHERE rid = %d', $rid);
      drupal_set_message('Role ' . $role['name'] . ' was deleted.');
    }
  }
}

// remove flags

function package_builder_uninstall_flags($path) {
  foreach (glob($path . '/flags/*.flag') as $importfile) {
    $file = file_get_contents($importfile);

    $flags = array();
    ob_start();
    eval($file);
    ob_end_clean();

    if (!isset($flags) || !is_array($flags)) {
      continue;
    }
    foreach ($flags as $flag_array) {

      $flag = flag_get_flag($flag_array['name']);
      if ($flag) {
        $flag->delete();
        $flag->disable();
        drupal_set_message('Flag ' . $flag->name . ' was deleted.');
      }
    }

  }
}

// remove *specific* nodes we installed

function package_builder_uninstall_nodes($path) {
  foreach (glob($path . '/nodes/*.node') as $importfile) {
    $node = array();

    ob_start();
    include $importfile;
    ob_end_clean();

    db_query("DELETE FROM {node} WHERE type = '%s' AND created = %d",
             $node['type'], $node['created']);
    drupal_set_message('Node ' . $node['title'] . ' was deleted.');
  }
}

// remove rules

function package_builder_uninstall_rules($path) {
  foreach (glob($path . '/rules/*.{rule,ruleset}', GLOB_BRACE) as $importfile) {
    $file = '$import = ' . file_get_contents($importfile) . ';';
    eval($file);

    if (!isset($import) || !is_array($import) || !count($import)) {
      drupal_set_message("Error importing $importfile", 'error');
      continue;
    }

    foreach ($import as $item_type => $elements) {
      foreach ($elements as $name => $element) {
        rules_item_delete($item_type, $name);
        drupal_set_message(t('Rule %label was deleted.',
                             array('%label' => rules_get_element_label($element))));
      }
    }
  }
  rules_clear_cache();
}


function package_builder_uninstall_users($path) {
  foreach (glob($path . '/users/*.user') as $importfile) {
    $user_ = array();

    ob_start();
    include $importfile;
    ob_end_clean();

    $arr = array();
    $arr['mail'] = $user_['mail'];
    $arr['name'] = $user_['name'];
    $user_ = user_load($arr);
    user_delete(NULL, $user_->uid);
    drupal_set_message('User ' . $arr['name'] . ' was deleted.');
  }  
}